/*

Location: Not stored (in-memory only)
Location scope: Local (only accessible from current query)
Time scope: Exist until execution completes
Indexable: No
Copy of data: No
Modifiable: Yes, modifies underlying data

*/

-- Basic Derived Table Usage

/*
select * from (
select myIntKey
     , myVarchar
     , 42 as [The Answer]
  from dbo.JK_Temp_Stuff_Test_Table
) JK_Derived_Table;
*/

-- Derived Table goes out of scope

/*
select * from (
select myIntKey
     , myVarchar
     , 42 as [The Answer]
  from dbo.JK_Temp_Stuff_Test_Table
) JK_Derived_Table

select * from JK_Derived_table;
*/

-- Derived Tables update underlying tables

/*
update tgt
   set myVarchar = 'Derived!'
  from dbo.JK_Temp_Stuff_Test_Table a
 inner join (select myVarchar, 42 as [The Answer]
               from dbo.JK_Temp_Stuff_Test_Table) tgt
         on a.myVarchar = tgt.myVarchar;

select *
  from dbo.JK_Temp_Stuff_Test_Table;
*/

--Cleanup

/*
update dbo.JK_Temp_Stuff_Test_Table set myVarchar = 'Wheeee';
*/