/*

Temp Tables:
* Anywhere you'll be reusing data multiple times during a session
* Can sub in for a query that is reused quite a bit
* Where indexing could help the execution plan
* Where you don't mind spilling to TempDB
* Where you don't need to modify the underlying data directly

Table Variables:
* Where you only intend to have one row in it
* Where you want cleanup to be automatic
* Where you don't mind spilling to TempDB
* Where you don't need to modify the underlying data directly

Views:
* When you're going to run the query over and over and over and over and over and...
* Commonly used joins can go here
* Anything that needs to persist forever, but with minimal impact on storage
* Where you need to modify the underlying data directly
* When you need to limit or grant access to the data
* When you need the latest answer at all times

CTEs:
* Where you want cleanup to be automatic
* Commonly used joins in your query can go here
* Only option for simple recursion
* When you want to do multiple things to the data along the way
* Where you need to modify the underlying data directly
* Where you don't want to spill to TempDB

Derived Tables:
* Good for encapsulating a query for testing
* Can improve performance when used in a join
* Where you don't need to reuse the query later
* Allows applying a condition universally across a complex query
* Can be inlined anywhere a view would fit (sometimes called an inline view)
* Can be nested relatively simply

*/